<script setup lang="ts">
import { storeToRefs } from 'pinia'
import { useChatStore } from '~/store/chat'
import { useAccountStore } from '~~/store/account'
import { useCallStore } from '~~/store/call'

const value = ref<string>('')
const chat = useChatStore()
const account = useAccountStore()
const call = useCallStore()
const { full } = storeToRefs(account)

// toggle ban
const { currentBan: ban } = storeToRefs(call)
const banModel = ref(false)
const banTitle = 'コメント機能を使用不可にします。'
const banMessage = 'よろしいですか？'
</script>

<template>
  <div class="flex flex-col h-full relative">
    <MChatList />
    <div class="bg-gray-200 text-center px-5 flex flex-row justify-center items-center dark:bg-gray-700">
      <div v-if="full" class="ml-auto flex relative">
        <ABaseCheckBox class="my-1" :model-value="ban" label="コメント機能使用不可" @update:model-value="chat.toggleBan" />
        <div v-show="!ban" class="overlay" @click="banModel = true" />
      </div>
    </div>
    <div class="flex flex-row items-center relative">
      <ATextAreaAuto
        class="flex-1"
        :min-rows="2"
        :max-rows="5"
        :value="ban ? '' : value"
        :disabled="ban"
        :placeholder="ban ? 'コメント機能は現在使用不可です。' : ''"
        @input="value = $event"
      />
      <button
        class="mx-5 lt-sm:mx-0 px-4 py-2 rounded-lg bg-blue-500 text-white text-lg"
        :disabled="value === ''"
        @click="
          () => {
            chat.chat(value)
            value = ''
          }
        "
      >
        送信
      </button>
    </div>
    <AWarningModel
      v-if="banModel"
      :text="banTitle"
      :message="banMessage"
      @close="banModel = false"
      @accept="
        () => {
          chat.toggleBan(true)
          banModel = false
        }
      "
    />
  </div>
</template>

<style scoped></style>
